#include "./ConsoleController.hpp"
#include <SFML/Window/Keyboard.hpp>
#include "../../Model/ModelConstants.hpp"

ConsoleController::ConsoleController()
{
	m_game = new Game();
}

ConsoleController::~ConsoleController()
{
	delete m_game;
}

void ConsoleController::play()
{
	//Intruction msg
	std::cout << "Use arrows to play !" << std::endl;

	//Init keyPress
	Direction keyPress;

	//Display the first grid
	m_game->showGrid();

	//Start game
	while (!m_game->isOver())
	{
		//Get key press
		keyPress=this->waitArrowKeyPress();

		//New line for the console print arrow press
		std::cout << std::endl;


		//Print keyPress
		switch(keyPress){
			case UP:
				std::cout << "Keypress : Up" << std::endl;
				break;
			case DOWN:
				std::cout << "Keypress : Down" << std::endl;
				break;
			case LEFT:
				std::cout << "Keypress : Left" << std::endl;
				break;
			case RIGHT:
				std::cout << "Keypress : Right" << std::endl;
				break;
		}

		//Show the Grid
		m_game->showGrid();
		std::cout << std::endl;


		//Pop new number
		m_game->pop();

	}
}



Direction ConsoleController::waitArrowKeyPress()
{
	//Initialise keyPress
	Direction keyPress;

	//Wait for keypress
	while(1){
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
		{
			keyPress=LEFT;
			while(sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
			{
				//Wait for release
			}
			break;
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
		{
			keyPress=RIGHT;
			while(sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
			{
				//Wait for release
			}
			break;
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
		{
			keyPress=UP;
			while(sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
			{
				//Wait for release
			}
			break;
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
		{
			// la touche "flèche gauche" est enfoncée : on bouge le personnage
			keyPress=DOWN;
			while(sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
			{
				//Wait for release
			}
			break;
		}
	}

	return keyPress;
}
